package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.community.commom.mode.ResponseBean;
import com.community.commom.session.UserElement;
import com.community.huiju.dao.TaUserVerifyMapper;
import com.community.huiju.dao.TpBuildingMapper;
import com.community.huiju.dao.TpBuildingOwnerInfoMapper;
import com.community.huiju.model.TaUserVerify;
import com.community.huiju.model.TpBuilding;
import com.community.huiju.model.TpBuildingOwnerInfo;
import com.community.huiju.model.TpTransaction;
import com.community.huiju.service.IBuildingOwnerInfo;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 楼栋资料库实现
 * @author weiximei
 */
@Slf4j
@Service
public class BuildingOwnerInfoImpl implements IBuildingOwnerInfo {

    @Autowired
    private TpBuildingMapper tpBuildingMapper;

    @Autowired
    private TpBuildingOwnerInfoMapper tpBuildingOwnerInfoMapper;

    @Autowired
    private TaUserVerifyMapper taUserVerifyMapper;

    @Override
    public ResponseBean selectBuildList(Integer communityId, Integer phaseId, Integer buildingId, Integer unitId, Integer levelId, Integer roomNoId) {
        ResponseBean responseBean = new ResponseBean();



        responseBean.addSuccess(null);
        return responseBean;
    }

    @Override
    public ResponseBean hasBuild(UserElement userElement,  Integer phaseId, Integer buildingId, Integer unitId, Integer levelId, Integer roomNoId) {
        ResponseBean responseBean = new ResponseBean();
        // 1.检验该用户关联有没有这个 户号
        TaUserVerify taUserVerify = taUserVerifyMapper.selectCommunityAndAddress(userElement.getId(),userElement.getCommunityId(), phaseId, buildingId, unitId, levelId, roomNoId);
        if (null != taUserVerify) {
            responseBean.addError("您已关联此房产，无法再次关联！");
            return responseBean;
        }

        Map<String,Object> result = Maps.newHashMap();

        // TODO 楼栋资料库查询有变动
        // 2.检验这个户号是否关联了 户主
        TpBuildingOwnerInfo tpBuildingOwnerInfo = tpBuildingOwnerInfoMapper.selectCommunityIdAndAddress(userElement.getCommunityId(), phaseId, buildingId, unitId, levelId, roomNoId);
        if (null != tpBuildingOwnerInfo) {
            result.put("ownerName",tpBuildingOwnerInfo.getOwnerName());
            result.put("roleName", "OWNER");
            responseBean.addSuccess(result);
            return responseBean;
        }

        responseBean.addError("该房产，暂无审核通过的业主！");
        return responseBean;
    }
}
